<?php
/*
Plugin Name: Fancy article loader
Plugin URI: http://sasakaranovic.com/projects/fancy-article-loader-wordpress-plugin/
Description: This plugin will enable users with JavaScript enabled to view your full article without reloading the page. When they click on the "Read more" link plugin will do it's magic and display the full article on the same page. It saves you some bandwith and users don't have to wait for the page to reload. However if user has disabled javascript he will be taken to view more page just like it used to before so you don't have to worry about that. Also I took care to keep your links intact. Enjoy! P.S. Please let me know if you like this plugin or have suggestions.
Version: 1.18
Author: Sasa Karanovic
Author URI: http://www.sasakaranovic.com/
License: GPL
*/

//Instal-UnInstall maintenence
/* Runs when plugin is activated */
register_activation_hook(__FILE__,'sk_fancy_article_install'); 

/* Runs on plugin deactivation*/
register_deactivation_hook( __FILE__, 'sk_fancy_article_remove' );

function sk_fancy_article_install() {
	/* Creates new database field */
	add_option("sk_fancy_article_has_jquery", '1', '', 'yes');
	add_option("sk_fancy_article_div_name", '', '', 'yes');
}

function sk_fancy_article_remove() {
	/* Deletes the database field */
	delete_option('sk_fancy_article_has_jquery');
	delete_option('sk_fancy_article_div_name');
}

//

function sk_fix_more_link($more) {
	$this_page_id = get_the_ID();
	
	preg_match('#<a\s*(?:href=[\'"]([^\'"]+)[\'"])?\s*(?:title=[\'"]([^\'"]+)[\'"])?.*?>((?:(?!</a>).)*)</a>#i',$more,$matches); 
	$link ="http://".str_replace("http://","",$matches[1]); 
	$more_text = strip_tags($more);
	$more = '<a href="'.$link.'" id="post-'. $this_page_id .'" class="more-link">'. $more_text . '</a>';
	return $more;
}


add_filter('the_content_more_link', 'sk_fix_more_link');


add_action('wp_head', 'sk_fancy_loader_jquery');

add_filter('the_content','sk_fancy_filter_post', 999);

function sk_fancy_filter_post($post) {
	$post_id = get_the_ID();
	?>
    <span class="fancyloader-post-<?=$post_id?>">
    <?=$post?>
    </span>
    <?php

}

function sk_fancy_loader_jquery($header) { 
$db_div_name = get_option('sk_fancy_article_div_name');
$full_path_to_plugin = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)); 
if (!empty($db_div_name) or $db_div_name!='') { $where_to_load = '"#'.$db_div_name.'"'; }
else { $where_to_load = '".fancyloader-"+post_id'; }
if (get_option('sk_fancy_article_has_jquery') == 1) { 
?>
<script type="text/javascript" src="<?= $full_path_to_plugin ?>jquery.js"></script>
<? } ?>
<script type="text/javascript">
	var $j = jQuery.noConflict();

	$j(function(){

		$j('.more-link').live("click", function(e)	{
			e.preventDefault();
			var post_id = $j(this).attr('id');
			var more_link = $j(this);
			more_link.text('Loading...');
			$j(<?=$where_to_load?>).load("<?= $full_path_to_plugin ?>ajax_get_post.php", { postid: post_id } );
			more_link.hide();
			
		});
	});
</script>
<?php
;
}


//Admin Page
if ( is_admin() ){
	/* Call the html code */
	add_action('admin_menu', 'sk_fancy_loader_admin_menu');
	
	function sk_fancy_loader_admin_menu() {
		add_options_page('Fancy Article Loader', 'Fancy Article Loader', 'administrator', 'sk-fancy-article-loader', 'sk_fancy_loader_admin_page');
	}
}


//Admin Page Look
function sk_fancy_loader_admin_page() {
	?>
<div class="wrap">
	<div id="icon-options-general" class="icon32"><br></div>

  <h2>Sasa Karanovic's Fancy Article Loader</h2>
    
<br />
<br />
  <h3 class="title">Configure your Fancy Article Loader plugin</h3>
	
	<form method="post" action="options.php">
    <table width="550" border="0">
      <tr>
        <th width="131" align="center" valign="middle">jQuery</th>
        <td width="359" align="left" valign="middle">
          <label>
            <input type="radio" name="sk_fancy_article_has_jquery" value="0" id="sk_fancy_article_has_jquery" <? if (get_option('sk_fancy_article_has_jquery') == 0) { echo 'checked="checked"'; } ?> />
            I have jQuery loaded so don't include it twice.</label>
          <br />
          <label>
        <input type="radio" name="sk_fancy_article_has_jquery" value="1" id="sk_fancy_article_has_jquery" <? if (get_option('sk_fancy_article_has_jquery') == 1) { echo 'checked="checked"'; } ?> />
            I DO NOT have jQuery loaded. Please load it.
        </label>
          <br />
        </td>
      </tr>
      <tr>
        <th width="131" align="center" valign="middle">&nbsp;</th>
        <td align="center" valign="middle">&nbsp;</td>
      </tr>
      <tr>
        <th align="center" valign="middle">Load post in external div</th>
        <td align="left" valign="middle"><input name="sk_fancy_article_div_name" type="text" id="sk_fancy_article_div_name" value="<?php echo get_option('sk_fancy_article_div_name'); ?>" />
        <br /></td>
      </tr>
      <tr>
        <td align="center" valign="middle">&nbsp;</td>
        <td align="left" valign="middle">If you want to load your posts in some other div type the div name in field above.. If you don't want to use this feature please just leave the box above empty.</td>
      </tr>
      <tr>
        <td align="center" valign="middle">&nbsp;</td>
        <td align="center" valign="middle">&nbsp;</td>
      </tr>
      <tr>
        <td colspan="2" align="center" valign="middle"><input type="submit" value="<?php _e('Save Changes') ?>" /></td>
      </tr>
        <tr valign="top">
        <td colspan="2" align="center" valign="middle" scope="row">&nbsp;</td>
        </tr>
        <tr valign="top">
        <td colspan="2" align="center" valign="middle" scope="row"><a href="http://twitter.com/?status=I+have+installed+new+SK+Fancy-Article-Loader+on+my+blog.+Check+it+out+here+http://is.gd/cJVW7+%23wordpress+%23plugin" target="_blank">If you like this plugin please tweet this message to let me know. Thank you!</a></td>
        </tr>
      </table>
    <?php wp_nonce_field('update-options'); ?>
	<input type="hidden" name="action" value="update" />
	<input type="hidden" name="page_options" value="sk_fancy_article_has_jquery,sk_fancy_article_div_name" />
	
	<p>&nbsp;</p>
	
  </form>
</div>
	<?php
}


?>
